#!/usr/bin/env python

from cElementTree import iterparse
from pprint import pprint
import sys

def parse_omssa_spectra(omssa_output):
    mspeptide = {}
    msprotein = {}
    spectra = {}
    omssa_tag = "{http://www.ncbi.nlm.nih.gov}"
    for event, group in iterparse(omssa_output,\
                                    events = ("start","end")):
        if event == "start" and \
            group.tag == omssa_tag+"MSHitSet_number":
            spectrum_id = group.text
        for protein in group.findall(omssa_tag+"MSPepHit_gi"):
            gi = protein.text
            mspeptide[spectrum_id,gi] = {"protein":gi}
        if event == "start" and \
            group.tag == omssa_tag+"MSHits_pepstring":
            pep_seq = group.text
            msprotein[spectrum_id,pep_seq,gi] = {"protein":gi,"peptide":pep_seq} 
    for prot in msprotein:
        spectrum = prot[0].strip()
        try:
            spectra[spectrum].append(msprotein[prot])
        except:
            spectra[spectrum] = []
            spectra[spectrum].append(msprotein[prot])
    return spectra

if __name__ == '__main__':

    omssaParsedResults= parse_omssa_spectra(sys.argv[1])
    pprint(omssaParsedResults)

