# encoding: utf-8
"""
targets.py

Created by Danny Navarro on 2008-04-04.
Copyright (c) 2008 __IOB__. All rights reserved.

This module contains the classes that will be created while parsing
MS/MS search results
"""


class Spectrum(object):
    """ MS/MS spectrum"""

    def __init__(self, id, parent_peak, peak_list=None):
        self.id = int(id)
        self.parent_peak = parent_peak
        self.peak_list = peak_list

class Peptide(object):
    """ A Peptide with all theoretical values 
    """

    def __init__(self, sequence, mass, missed_cleavages=0,
                protein_matches=None):
        self.mass = mass
        self.sequence = sequence
        self.missed_cleavages = missed_cleavages
        self.protein_matches = protein_matches

# TODO:
#    def is_semitrypic(self):
#       self



class PSM(object):
    """
    Peptide to spectrum, match between spectrum and peptide
    """
    def __init__(self, peptide, spectrum, dmass, score, evalue):
        self.peptide = peptide
        self.spectrum = spectrum
        self.dmass = float(dmass)
        self.score = float(score)
        self.evalue = float(evalue)

class PTM(object):
    """ Modifications for Aa 
    """
    def __init__(self, symbol, mass, allowed_Aa):
        self.symbol = symbol
        self.mass = mass
        self.allowed_Aa = allowed_Aa

